<?php
/**
 * Quantity Discounts in the order_total module
 * By That Software Guy (help@thatsoftwareguy.com) 
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 */

  class ot_quantity_discount {
    var $title, $output;

    function ot_quantity_discount() {
      $this->code = 'ot_quantity_discount';
      $this->title = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TITLE;
      $this->description = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_DESCRIPTION;
      $this->sort_order = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_SORT_ORDER;
      $this->include_shipping = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_SHIPPING;
      $this->include_tax = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_TAX;
      $this->calculate_tax = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_CALC_TAX;
      $this->credit_tax = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_CREDIT_TAX;
      $this->total_basis = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TOTAL_BASIS;
      $this->units = MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_UNITS;
      $this->total_level_1 = MODULE_ORDER_TOTAL_LEVEL_1;
      $this->total_discount_1 = MODULE_ORDER_TOTAL_DISCOUNT_1; 
      $this->total_level_2 = MODULE_ORDER_TOTAL_LEVEL_2;
      $this->total_discount_2 = MODULE_ORDER_TOTAL_DISCOUNT_2;
      $this->total_level_3 = MODULE_ORDER_TOTAL_LEVEL_3;
      $this->total_discount_3 = MODULE_ORDER_TOTAL_DISCOUNT_3;
      $this->total_level_4 = MODULE_ORDER_TOTAL_LEVEL_4;
      $this->total_discount_4 = MODULE_ORDER_TOTAL_DISCOUNT_4;
      $this->total_level_5 = MODULE_ORDER_TOTAL_LEVEL_5; 
      $this->total_discount_5 = MODULE_ORDER_TOTAL_DISCOUNT_5;

      $this->output = array();
    }
    
    function print_amount($amount) {
      global $db, $order, $currencies;
      return  $currencies->format($amount, true, $order->info['currency'], $order->info['currency_value']);
    }

    function process() {
      global $db, $order, $currencies;

      $products = $_SESSION['cart']->get_products();
      $prod_list = array();
      $prod_list_price = array();
      $prod_list_model= array();
      $cat_list = array();
      $cat_list_price = array();
      $cat_list_model= array();
      $all_items = 0;
      $all_items_price = 0;
      for ($i=0, $n=sizeof($products); $i<$n; $i++) {
           // by category
           $cat_list_model[$products[$i]['category']] = $products[$i]['category'];
           $cat_list[$products[$i]['category']] += $products[$i]['quantity'];
           $cat_list_price[$products[$i]['category']] += ($products[$i]['final_price'] * $products[$i]['quantity']);

           // by products
           $prod_list_model[$products[$i]['id']] = $products[$i]['model'];
           $prod_list[$products[$i]['id']] += $products[$i]['quantity'];
           $prod_list_price[$products[$i]['id']] += ($products[$i]['final_price'] * $products[$i]['quantity']);

           // by cart total
           $all_items += $products[$i]['quantity'];
           $all_items_price += ($products[$i]['final_price'] * $products[$i]['quantity']);
      }

        $order_total = $this->get_order_total();
        $gift_vouchers = $_SESSION['cart']->gv_only();
        
/*
        if ($this->units == 'currency') {
           $discount = $group_discount->fields['group_percentage'];
        } else  {
           $discount = ($order_total - $gift_vouchers) * $group_discount->fields['group_percentage'] / 100;
        }
*/
        $cart_array = false;
        $key_list = array();
        $item_list = array();
        $price_list = array();
        $model_list = array();
        if ($this->total_basis == 'Total By Category') {
           $key_list = array_keys($cat_list); 
           $item_list = $cat_list;
           $price_list = $cat_list_price; 
           $model_list = $cat_list_model;
           $cart_array = true;
        } else if ($this->total_basis == 'Total By Item') {
           $key_list = array_keys($prod_list); 
           $item_list = $prod_list;
           $price_list = $prod_list_price; 
           $model_list = $prod_list_model;
           $cart_array = true;
        } 

        $discount = 0;
        $explanation = ALERT_HEADER . "\\n" . "\\n"; 
        if ($cart_array == true) {
           // Discount by category or item number
           while (list($keypos, $listpos) = each($key_list)) {
                 $count =  $item_list[$listpos];
                 $price =  $price_list[$listpos];
                 if ($this->total_basis == 'Total By Category') {
                    $model =  zen_get_category_name($model_list[$listpos],  $_SESSION['languages_id']) . " " . ITEMS;
                 } else { 
                    $model =  $model_list[$listpos];
                 }
                 if ($count < $this->total_level_1) 
                      continue; 
                 $disc_amount = $this->total_discount_1;
                 if ($count >= $this->total_level_2) 
                     $disc_amount = max($disc_amount, $this->total_discount_2);
                 if ($count >= $this->total_level_3) 
                     $disc_amount = max($disc_amount, $this->total_discount_3);
                 if ($count >= $this->total_level_4) 
                     $disc_amount = max($disc_amount, $this->total_discount_4);
                 if ($count >= $this->total_level_5) 
                     $disc_amount = max($disc_amount, $this->total_discount_5);
                  
                 if ($this->units == 'currency') {
                    $this_discount = $disc_amount; 
                 } else  {
                    $this_discount = $price * $disc_amount / 100;
                 }
                 if ($this_discount > $price)  {
                    $this_discount = $price;
                 }

                 if ($this->units == 'currency') {
                    $explanation .= " " . 
                       $this->print_amount($this_discount) . OFF . 
                        $count . " " . 
                        $model . "@" .  
                       $this->print_amount($price) . "\\n";
                 } else {
                    $explanation .=  " " . $count . " " . 
                       $model . "@" .  
                       $this->print_amount($price) . " * " . $disc_amount .  "% = " . 
                       $this->print_amount($this_discount) . "\\n"; 
                 } 
                 $discount +=  $this_discount;
           }
        } else {
           $count = $all_items; 
           $price = $all_items_price; 
           if ($count < $this->total_level_1) 
                continue; 
           $disc_amount = $this->total_discount_1;
           if ($count >= $this->total_level_2) 
               $disc_amount = max($disc_amount, $this->total_discount_2);
           if ($count >= $this->total_level_3) 
               $disc_amount = max($disc_amount, $this->total_discount_3);
           if ($count >= $this->total_level_4) 
               $disc_amount = max($disc_amount, $this->total_discount_4);
           if ($count >= $this->total_level_5) 
               $disc_amount = max($disc_amount, $this->total_discount_5);
            
           if ($this->units == 'currency') {
              $this_discount = $disc_amount; 
           } else  {
              $this_discount = $price * $disc_amount / 100;
           }
           if ($this_discount > $price)  {
              $this_discount = $price;
           }
           // Discount by total items in cart
           $discount = $this_discount;
           if ($this->units == 'currency') {
               $explanation .= " " . 
                       $this->print_amount($this_discount) . OFF . 
                        $count . " " . 
                        ITEMS . " @ " .  
                       $this->print_amount($price) . "\\n";
           } else {
               $explanation .=  " " . $count . " " . 
                       ITEMS . " @ " .  
                       $this->print_amount($price) . " * " . $disc_amount .  "% = " . 
                       $this->print_amount($this_discount) . "\\n"; 
           } 
        }
        $explanation .= "\\n\\n" . TOTAL_DISCOUNT . $this->print_amount($discount); 

        $od_amount = zen_round($discount, 2);
        if ($this->calculate_tax != "none") {
          $tod_amount = $this->calculate_tax_deduction($order_total, $od_amount, $this->calculate_tax, true);
        }
        $this->deduction = $od_amount;
        if ($discount > 0 ) {
          $order->info['total'] -= $this->deduction;
          $this->title = '<a href="javascript:alert(\'' . $explanation . '\');">' . $this->title . '</a>'; 
          $this->output[] = array('title' => $this->title . ':',
                                  'text' => '-' . $currencies->format($this->deduction, true, $order->info['currency'], $order->info['currency_value']),
                                  'value' => $this->deduction);
        }
    }

    function get_order_total() {
      global $order;
      $order_total = $order->info['total'];
      if ($this->include_tax == 'false') $order_total = $order_total - $order->info['tax'];
      if ($this->include_shipping == 'false') $order_total = $order_total - $order->info['shipping_cost'];

      return $order_total;
    }

    function calculate_tax_deduction($amount, $od_amount, $method, $finalise = false) {
      global $order;
      $tax_address = zen_get_tax_locations();
      switch ($method) {
        case 'Standard':
        if ($amount == 0) {
          $ratio1 = 0;
        } else {
          $ratio1 = zen_round($od_amount / $amount,2);
        }
        $tod_amount = 0;
        reset($order->info['tax_groups']);
        while (list($key, $value) = each($order->info['tax_groups'])) {
          $tax_rate = zen_get_tax_rate_from_desc($key, $tax_address['country_id'], $tax_address['zone_id']);
          $total_net += $tax_rate * $value;
        }
        if ($od_amount > $total_net) $od_amount = $total_net;
        reset($order->info['tax_groups']);
        while (list($key, $value) = each($order->info['tax_groups'])) {
          $tax_rate = zen_get_tax_rate_from_desc($key, $tax_address['country_id'], $tax_address['zone_id']);
          $net = $tax_rate * $value;
          if ($net > 0) {
            $god_amount = $value * $ratio1;
            $tod_amount += $god_amount;
            if ($finalise) $order->info['tax_groups'][$key] = $order->info['tax_groups'][$key] - $god_amount;
          }
        }
        if ($finalise) $order->info['tax'] -= $tod_amount;
        if ($finalise) $order->info['total'] -= $tod_amount;
        break;
        case 'Credit Note':
          $tax_rate = zen_get_tax_rate($this->tax_class, $tax_address['country_id'], $tax_address['zone_id']);
          $tax_desc = zen_get_tax_description($this->tax_class, $tax_address['country_id'], $tax_address['zone_id']);
          $tod_amount = $this->deduction / (100 + $tax_rate)* $tax_rate;
          if ($finalise) $order->info['tax_groups'][$tax_desc] -= $tod_amount;
          if ($finalise) $order->info['tax'] -= $tod_amount;
          if ($finalise) $order->info['total'] -= $tod_amount;
        break;
        default:
      }
      return zen_round($tod_amount, 2);
    }

    function credit_selection() {
      return $selection;
    }

    function collect_posts() {
    }

    function update_credit_account($i) {
    }

    function apply_credit() {
    }

    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_STATUS'");
        $this->_check = $check_query->RecordCount();
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_STATUS', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_SORT_ORDER', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_SHIPPING', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_TAX', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_CALC_TAX', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_UNITS', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TOTAL_BASIS', 'MODULE_ORDER_TOTAL_LEVEL_1','MODULE_ORDER_TOTAL_DISCOUNT_1','MODULE_ORDER_TOTAL_LEVEL_2','MODULE_ORDER_TOTAL_DISCOUNT_2','MODULE_ORDER_TOTAL_LEVEL_3','MODULE_ORDER_TOTAL_DISCOUNT_3','MODULE_ORDER_TOTAL_LEVEL_4','MODULE_ORDER_TOTAL_DISCOUNT_4','MODULE_ORDER_TOTAL_LEVEL_5','MODULE_ORDER_TOTAL_DISCOUNT_5','MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TAX_CLASS');
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('This module is installed', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_STATUS', 'true', '', '6', '1','zen_cfg_select_option(array(\'true\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_SORT_ORDER', '295', 'Sort order of display.', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Include Shipping', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_SHIPPING', 'false', 'Include Shipping in calculation', '6', '5', 'zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Include Tax', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_INC_TAX', 'false', 'Include Tax in calculation.', '6', '6','zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Re-calculate Tax', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_CALC_TAX', 'Standard', 'Re-Calculate Tax', '6', '7','zen_cfg_select_option(array(\'None\', \'Standard\', \'Credit Note\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Discount Basis', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TOTAL_BASIS', 'Total By Category', 'How quantity totals are computed', '6', '8','zen_cfg_select_option(array(\'Total By Category\', \'Total By Item\', \'Total Items in Cart\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Discount Units', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_UNITS', 'currency', 'Discounts expressed as a currency unit (e.g. dollars) or as a percentage ', '6', '9', 'zen_cfg_select_option(array(\'currency\', \'percentage\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Level 1', 'MODULE_ORDER_TOTAL_LEVEL_1', '0', 'Total required to reach this discount level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Amount 1', 'MODULE_ORDER_TOTAL_DISCOUNT_1', '0', 'Percent or amount off at this level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Level 2', 'MODULE_ORDER_TOTAL_LEVEL_2', '0', 'Total required to reach this discount level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount 2', 'MODULE_ORDER_TOTAL_DISCOUNT_2', '0', 'Percent or amount off at this level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Level 3', 'MODULE_ORDER_TOTAL_LEVEL_3', '0', 'Total required to reach this discount level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount 3', 'MODULE_ORDER_TOTAL_DISCOUNT_3', '0', 'Percent or amount off at this level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Level 4', 'MODULE_ORDER_TOTAL_LEVEL_4', '0', 'Total required to reach this discount level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount 4', 'MODULE_ORDER_TOTAL_DISCOUNT_4', '0', 'Percent or amount off at this level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Level 5', 'MODULE_ORDER_TOTAL_LEVEL_5', '0', 'Total required to reach this discount level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount 5', 'MODULE_ORDER_TOTAL_DISCOUNT_5', '0', 'Percent or amount off at this level', '6', '5', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_QUANTITY_DISCOUNT_TAX_CLASS', '0', 'Use the following tax class when treating Quantity Discount as Credit Note.', '6', '0', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
